<template>
  <div class="container">
    <v-btn icon @click="copyToClipboard">
      <v-icon color="white">
        mdi-content-copy
      </v-icon>
    </v-btn>
    <div v-for="(item, index) in Object.keys(opus)" :key="index">
      <div v-if="item === 'contributors'">
        <div v-for="(c, cIndex) in Object.keys(opus[item])" :key="cIndex">
          contributors.<b>{{ c }}</b> : {{ opus[item][c] }}
        </div>
      </div>
      <div v-else>
        <b>{{ item }}</b> : {{ opus[item] }}
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { Component, Prop, Vue } from 'vue-property-decorator';

@Component
export default class OpusTooltip extends Vue {
  @Prop({ required: true })
  // eslint-disable-next-line @typescript-eslint/no-explicit-any
  opus: any;

  copyToClipboard() {
    let text = '';
    const items = Object.keys(this.opus);
    for (let i = 0; i < items.length; i += 1) {
      const item = items[i];
      if (item === 'contributors') {
        const contributors = Object.keys(this.opus[item]);
        for (let j = 0; j < contributors.length; j += 1) {
          text += `contributors.${contributors[j]}: ${this.opus[item][contributors[j]]}\n`;
        }
      } else {
        text += `${item}: ${this.opus[item]}\n`;
      }
    }
    navigator.clipboard.writeText(text);
    this.$dialog.notify.success('Copied!', {
      position: 'top-center',
      dismissible: true,
    });
  }
}
</script>

<style lang="scss" scoped>
.container {
  color: white;
  background-color: rgba(97, 97, 97, 0.9);
  padding: 5px 16px;
  opacity: .9;
  border-radius: 4px;
}
</style>
